Index: netinet/rfc6056.c
===================================================================
RCS file: /cvsroot/src/sys/netinet/rfc6056.c,v
retrieving revision 1.3
diff -u -b -r1.3 rfc6056.c
--- netinet/rfc6056.c	25 Sep 2011 11:54:28 -0000	1.3
+++ netinet/rfc6056.c	31 Oct 2011 04:29:26 -0000
@@ -39,6 +39,7 @@
 #include <sys/uidinfo.h>
 #include <sys/domain.h>
 #include <sys/md5.h>
+#include <sys/cprng.h>
 
 #include <net/if.h>
 #include <net/route.h>
@@ -427,7 +428,7 @@
 
 	DPRINTF("num_ephemeral: %u\n", num_ephemeral);
 
-	*next_ephemeral = mymin + (arc4random() % num_ephemeral);
+	*next_ephemeral = mymin + (cprng_fast32() % num_ephemeral);
 
 	DPRINTF("next_ephemeral initially: %u\n", *next_ephemeral);
 
@@ -480,7 +481,7 @@
 	num_ephemeral = mymax - mymin + 1;
 
 	DPRINTF("num_ephemeral: %u\n", num_ephemeral);
-	*next_ephemeral = mymin + (arc4random() % num_ephemeral);
+	*next_ephemeral = mymin + (cprng_fast32() % num_ephemeral);
 
 	DPRINTF("next_ephemeral initially: %u\n", *next_ephemeral);
 
@@ -493,7 +494,7 @@
 			return 0;
 		}
 		*next_ephemeral = mymin +
-		    (arc4random() % num_ephemeral);
+		    (cprng_fast32() % num_ephemeral);
 
 		count--;
 
@@ -516,10 +517,7 @@
 	uint32_t offset;
 	uint16_t soffset[2];
 
-	secret_f[0] = arc4random();
-	secret_f[1] = arc4random();
-	secret_f[2] = arc4random();
-	secret_f[3] = arc4random();
+	cprng_fast(secret_f, sizeof(secret_f));
 
 	MD5Init(&f_ctx);
 	switch (inp_hdr->inph_af) {
@@ -732,7 +730,7 @@
 		return error;
 
 	if (*next_ephemeral == 0)
-		*next_ephemeral = arc4random() & 0xffff;
+		*next_ephemeral = cprng_fast32() & 0xffff;
 
 	/* Ephemeral port selection function */
 	num_ephemeral = mymax - mymin + 1;
@@ -740,7 +738,7 @@
 	count = num_ephemeral;
 	do {
 		*next_ephemeral = *next_ephemeral +
-		    (arc4random() % N) + 1;
+		    (cprng_fast32() % N) + 1;
 		myport = mymin +
 		    (*next_ephemeral % num_ephemeral);
 
Index: netinet/tcp_input.c
===================================================================
RCS file: /cvsroot/src/sys/netinet/tcp_input.c,v
retrieving revision 1.316
diff -u -b -r1.316 tcp_input.c
--- netinet/tcp_input.c	31 Aug 2011 18:31:03 -0000	1.316
+++ netinet/tcp_input.c	31 Oct 2011 04:29:27 -0000
@@ -171,6 +171,7 @@
 #include <sys/md5.h>
 #endif
 #include <sys/lwp.h> /* for lwp0 */
+#include <sys/cprng.h>
 
 #include <net/if.h>
 #include <net/route.h>
@@ -3711,8 +3712,8 @@
 	 * the hash secrets.
 	 */
 	if (syn_cache_count == 0) {
-		syn_hash1 = arc4random();
-		syn_hash2 = arc4random();
+		syn_hash1 = cprng_fast32();
+		syn_hash2 = cprng_fast32();
 	}
 
 	SYN_HASHALL(sc->sc_hash, &sc->sc_src.sa, &sc->sc_dst.sa);
Index: netinet/tcp_subr.c
===================================================================
RCS file: /cvsroot/src/sys/netinet/tcp_subr.c,v
retrieving revision 1.241
diff -u -b -r1.241 tcp_subr.c
--- netinet/tcp_subr.c	3 May 2011 18:28:45 -0000	1.241
+++ netinet/tcp_subr.c	31 Oct 2011 04:29:27 -0000
@@ -98,7 +98,6 @@
 #include "opt_tcp_compat_42.h"
 #include "opt_inet_csum.h"
 #include "opt_mbuftrace.h"
-#include "rnd.h"
 
 #include <sys/param.h>
 #include <sys/proc.h>
@@ -111,10 +110,8 @@
 #include <sys/errno.h>
 #include <sys/kernel.h>
 #include <sys/pool.h>
-#if NRND > 0
 #include <sys/md5.h>
-#include <sys/rnd.h>
-#endif
+#include <sys/cprng.h>
 
 #include <net/route.h>
 #include <net/if.h>
@@ -174,9 +171,7 @@
 int	tcp_minmss = TCP_MINMSS;
 int 	tcp_rttdflt = TCPTV_SRTTDFLT / PR_SLOWHZ;
 int	tcp_do_rfc1323 = 1;	/* window scaling / timestamps (obsolete) */
-#if NRND > 0
 int	tcp_do_rfc1948 = 0;	/* ISS by cryptographic hash */
-#endif
 int	tcp_do_sack = 1;	/* selective acknowledgement */
 int	tcp_do_win_scale = 1;	/* RFC1323 window scaling */
 int	tcp_do_timestamps = 1;	/* RFC1323 timestamps */
@@ -2178,9 +2173,7 @@
 }
 
 tcp_seq	 tcp_iss_seq = 0;	/* tcp initial seq # */
-#if NRND > 0
 u_int8_t tcp_iss_secret[16];	/* 128 bits; should be plenty */
-#endif
 
 /*
  * Get a new sequence value given a tcp control block
@@ -2218,7 +2211,6 @@
 {
 	tcp_seq tcp_iss;
 
-#if NRND > 0
 	static bool tcp_iss_gotten_secret;
 
 	/*
@@ -2226,8 +2218,8 @@
 	 * hash secret.
 	 */
 	if (tcp_iss_gotten_secret == false) {
-		rnd_extract_data(tcp_iss_secret, sizeof(tcp_iss_secret),
-		    RND_EXTRACT_ANY);
+		cprng_strong(kern_cprng,
+			     tcp_iss_secret, sizeof(tcp_iss_secret));
 		tcp_iss_gotten_secret = true;
 	}
 
@@ -2268,17 +2260,11 @@
 #ifdef TCPISS_DEBUG
 		printf("new ISS 0x%08x\n", tcp_iss);
 #endif
-	} else
-#endif /* NRND > 0 */
-	{
+	} else {
 		/*
 		 * Randomize.
 		 */
-#if NRND > 0
-		rnd_extract_data(&tcp_iss, sizeof(tcp_iss), RND_EXTRACT_ANY);
-#else
-		tcp_iss = arc4random();
-#endif
+		tcp_iss = cprng_fast32();
 
 		/*
 		 * If we were asked to add some amount to a known value,
Index: netinet6/files.ipsec
===================================================================
RCS file: /cvsroot/src/sys/netinet6/files.ipsec,v
retrieving revision 1.5
diff -u -b -r1.5 files.ipsec
--- netinet6/files.ipsec	27 Oct 2006 21:20:48 -0000	1.5
+++ netinet6/files.ipsec	31 Oct 2011 04:29:27 -0000
@@ -1,7 +1,7 @@
 #	$NetBSD: files.ipsec,v 1.5 2006/10/27 21:20:48 christos Exp $
 
-defflag opt_ipsec.h		IPSEC: rijndael
-defflag opt_ipsec.h		IPSEC_ESP: des, blowfish, cast128, rijndael
+defflag opt_ipsec.h		IPSEC
+defflag opt_ipsec.h		IPSEC_ESP: des, blowfish, cast128
 defflag opt_ipsec.h		IPSEC_NAT_T
 
 file	netinet6/ah_aesxcbcmac.c	ipsec
Index: netinet6/in6.c
===================================================================
RCS file: /cvsroot/src/sys/netinet6/in6.c,v
retrieving revision 1.158
diff -u -b -r1.158 in6.c
--- netinet6/in6.c	19 Oct 2011 01:53:07 -0000	1.158
+++ netinet6/in6.c	31 Oct 2011 04:29:27 -0000
@@ -81,6 +81,7 @@
 #include <sys/kernel.h>
 #include <sys/syslog.h>
 #include <sys/kauth.h>
+#include <sys/cprng.h>
 
 #include <net/if.h>
 #include <net/if_types.h>
@@ -1119,7 +1120,7 @@
 			 * avoid report collision.
 			 * [draft-ietf-ipv6-rfc2462bis-02.txt]
 			 */
-			dad_delay = arc4random() %
+			dad_delay = cprng_fast32() %
 			    (MAX_RTR_SOLICITATION_DELAY * hz);
 		}
 
@@ -1210,7 +1211,7 @@
 			 * The spec doesn't say anything about delay for this
 			 * group, but the same logic should apply.
 			 */
-			dad_delay = arc4random() %
+			dad_delay = cprng_fast32() %
 			    (MAX_RTR_SOLICITATION_DELAY * hz);
 		}
 		if (in6_nigroup(ifp, hostname, hostnamelen, &mltaddr) != 0)
@@ -1318,7 +1319,7 @@
 				dad_delay = 0;
 			else {
 				dad_delay =
-				    (arc4random() % (maxdelay - mindelay)) +
+				    (cprng_fast32() % (maxdelay - mindelay)) +
 				    mindelay;
 			}
 		}
@@ -2157,7 +2158,8 @@
 			 * case, but we impose delays just in case.
 			 */
 			nd6_dad_start(ifa,
-			    arc4random() % (MAX_RTR_SOLICITATION_DELAY * hz));
+			    cprng_fast32() %
+				(MAX_RTR_SOLICITATION_DELAY * hz));
 		}
 	}
 
Index: netinet6/in6_ifattach.c
===================================================================
RCS file: /cvsroot/src/sys/netinet6/in6_ifattach.c,v
retrieving revision 1.85
diff -u -b -r1.85 in6_ifattach.c
--- netinet6/in6_ifattach.c	19 Sep 2009 13:11:02 -0000	1.85
+++ netinet6/in6_ifattach.c	31 Oct 2011 04:29:28 -0000
@@ -43,6 +43,7 @@
 #include <sys/syslog.h>
 #include <sys/md5.h>
 #include <sys/socketvar.h>
+#include <sys/cprng.h>
 
 #include <net/if.h>
 #include <net/if_dl.h>
@@ -177,7 +178,6 @@
 {
 	MD5_CTX ctxt;
 	u_int8_t seed[16], digest[16], nullbuf[8];
-	u_int32_t val32;
 	/*
 	 * interface ID for subnet anycast addresses.
 	 * XXX: we assume the unicast address range that requires IDs
@@ -191,12 +191,7 @@
 	/* If there's no hisotry, start with a random seed. */
 	memset(nullbuf, 0, sizeof(nullbuf));
 	if (memcmp(nullbuf, seed0, sizeof(nullbuf)) == 0) {
-		int i;
-
-		for (i = 0; i < 2; i++) {
-			val32 = arc4random();
-			memcpy(seed + sizeof(val32) * i, &val32, sizeof(val32));
-		}
+		cprng_fast(seed, sizeof(seed));
 	} else
 		memcpy(seed, seed0, 8);
 
Index: netinet6/ip6_id.c
===================================================================
RCS file: /cvsroot/src/sys/netinet6/ip6_id.c,v
retrieving revision 1.16
diff -u -b -r1.16 ip6_id.c
--- netinet6/ip6_id.c	30 Aug 2006 17:11:53 -0000	1.16
+++ netinet6/ip6_id.c	31 Oct 2011 04:29:28 -0000
@@ -85,6 +85,8 @@
 __KERNEL_RCSID(0, "$NetBSD: ip6_id.c,v 1.16 2006/08/30 17:11:53 christos Exp $");
 
 #include <sys/param.h>
+#include <sys/cprng.h>
+
 #include <lib/libkern/libkern.h>
 
 #include <net/if.h>
@@ -175,20 +177,20 @@
 	u_int32_t j, i;
 	int noprime = 1;
 
-	p->ru_x = arc4random() % p->ru_m;
+	p->ru_x = cprng_fast32() % p->ru_m;
 
 	/* (bits - 1) bits of random seed */
-	p->ru_seed = arc4random() & (~0U >> (32 - p->ru_bits + 1));
-	p->ru_seed2 = arc4random() & (~0U >> (32 - p->ru_bits + 1));
+	p->ru_seed = cprng_fast32() & (~0U >> (32 - p->ru_bits + 1));
+	p->ru_seed2 = cprng_fast32() & (~0U >> (32 - p->ru_bits + 1));
 
 	/* Determine the LCG we use */
-	p->ru_b = (arc4random() & (~0U >> (32 - p->ru_bits))) | 1;
+	p->ru_b = (cprng_fast32() & (~0U >> (32 - p->ru_bits))) | 1;
 	p->ru_a = pmod(p->ru_agen,
-	    (arc4random() & (~0U >> (32 - p->ru_bits))) & (~1U), p->ru_m);
+	    (cprng_fast32() & (~0U >> (32 - p->ru_bits))) & (~1U), p->ru_m);
 	while (p->ru_b % 3 == 0)
 		p->ru_b += 2;
 
-	j = arc4random() % p->ru_n;
+	j = cprng_fast32() % p->ru_n;
 
 	/*
 	 * Do a fast gcd(j, RU_N - 1), so we can find a j with
@@ -222,7 +224,7 @@
 		initid(p);
 
 	/* Skip a random number of ids */
-	n = arc4random() & 0x3;
+	n = cprng_fast32() & 0x3;
 	if (p->ru_counter + n >= p->ru_max)
 		initid(p);
 
Index: netinet6/ip6_input.c
===================================================================
RCS file: /cvsroot/src/sys/netinet6/ip6_input.c,v
retrieving revision 1.132
diff -u -b -r1.132 ip6_input.c
--- netinet6/ip6_input.c	1 Jun 2011 22:59:44 -0000	1.132
+++ netinet6/ip6_input.c	31 Oct 2011 04:29:28 -0000
@@ -85,6 +85,7 @@
 #include <sys/syslog.h>
 #include <sys/proc.h>
 #include <sys/sysctl.h>
+#include <sys/cprng.h>
 
 #include <net/if.h>
 #include <net/if_types.h>
@@ -190,7 +191,7 @@
 	addrsel_policy_init();
 	nd6_init();
 	frag6_init();
-	ip6_desync_factor = arc4random() % MAX_TEMP_DESYNC_FACTOR;
+	ip6_desync_factor = cprng_fast32() % MAX_TEMP_DESYNC_FACTOR;
 
 	ip6_init2((void *)0);
 #ifdef GATEWAY
Index: netinet6/mld6.c
===================================================================
RCS file: /cvsroot/src/sys/netinet6/mld6.c,v
retrieving revision 1.54
diff -u -b -r1.54 mld6.c
--- netinet6/mld6.c	19 Oct 2011 01:53:07 -0000	1.54
+++ netinet6/mld6.c	31 Oct 2011 04:29:28 -0000
@@ -116,6 +116,7 @@
 #include <sys/sysctl.h>
 #include <sys/kernel.h>
 #include <sys/callout.h>
+#include <sys/cprng.h>
 
 #include <net/if.h>
 
@@ -289,7 +290,7 @@
 		in6m->in6m_state = MLD_OTHERLISTENER;
 	} else {
 		mld_sendpkt(in6m, MLD_LISTENER_REPORT, NULL);
-		in6m->in6m_timer = arc4random() %
+		in6m->in6m_timer = cprng_fast32() %
 		    (MLD_UNSOLICITED_REPORT_INTERVAL * hz);
 		in6m->in6m_state = MLD_IREPORTEDLAST;
 
@@ -443,7 +444,7 @@
 			} else if (in6m->in6m_timer == IN6M_TIMER_UNDEF ||
 			    mld_timerresid(in6m) > timer) {
 				in6m->in6m_timer =
-				   1 + (arc4random() % timer) * hz / 1000;
+				   1 + (cprng_fast32() % timer) * hz / 1000;
 				mld_starttimer(in6m);
 			}
 		}
Index: netinet6/mld6_var.h
===================================================================
RCS file: /cvsroot/src/sys/netinet6/mld6_var.h,v
retrieving revision 1.9
diff -u -b -r1.9 mld6_var.h
--- netinet6/mld6_var.h	1 Nov 2007 20:33:58 -0000	1.9
+++ netinet6/mld6_var.h	31 Oct 2011 04:29:28 -0000
@@ -35,7 +35,7 @@
 
 #ifdef _KERNEL
 
-#define MLD_RANDOM_DELAY(X)	(arc4random() % (X) + 1)
+#define MLD_RANDOM_DELAY(X)	(cprng_fast32() % (X) + 1)
 
 /*
  * States for MLD stop-listening processing
Index: netinet6/nd6.c
===================================================================
RCS file: /cvsroot/src/sys/netinet6/nd6.c,v
retrieving revision 1.136
diff -u -b -r1.136 nd6.c
--- netinet6/nd6.c	15 Jul 2010 19:15:30 -0000	1.136
+++ netinet6/nd6.c	31 Oct 2011 04:29:29 -0000
@@ -50,6 +50,7 @@
 #include <sys/ioctl.h>
 #include <sys/syslog.h>
 #include <sys/queue.h>
+#include <sys/cprng.h>
 
 #include <net/if.h>
 #include <net/if_dl.h>
Index: netinet6/nd6.h
===================================================================
RCS file: /cvsroot/src/sys/netinet6/nd6.h,v
retrieving revision 1.54
diff -u -b -r1.54 nd6.h
--- netinet6/nd6.h	24 May 2011 18:07:11 -0000	1.54
+++ netinet6/nd6.h	31 Oct 2011 04:29:29 -0000
@@ -260,7 +260,7 @@
 #define TEMPADDR_REGEN_ADVANCE		5	/* sec */
 #define MAX_TEMP_DESYNC_FACTOR		600	/* 10 min */
 #define ND_COMPUTE_RTIME(x) \
-		(((MIN_RANDOM_FACTOR * (x >> 10)) + (arc4random() & \
+		(((MIN_RANDOM_FACTOR * (x >> 10)) + (cprng_fast32() & \
 		((MAX_RANDOM_FACTOR - MIN_RANDOM_FACTOR) * (x >> 10)))) /1000)
 
 TAILQ_HEAD(nd_drhead, nd_defrouter);
Index: netinet6/nd6_rtr.c
===================================================================
RCS file: /cvsroot/src/sys/netinet6/nd6_rtr.c,v
retrieving revision 1.81
diff -u -b -r1.81 nd6_rtr.c
--- netinet6/nd6_rtr.c	24 May 2011 18:07:11 -0000	1.81
+++ netinet6/nd6_rtr.c	31 Oct 2011 04:29:29 -0000
@@ -44,6 +44,7 @@
 #include <sys/errno.h>
 #include <sys/ioctl.h>
 #include <sys/syslog.h>
+#include <sys/cprng.h>
 
 #include <net/if.h>
 #include <net/if_types.h>
Index: netkey/key.c
===================================================================
RCS file: /cvsroot/src/sys/netkey/key.c,v
retrieving revision 1.179
diff -u -b -r1.179 key.c
--- netkey/key.c	17 Jul 2011 20:54:54 -0000	1.179
+++ netkey/key.c	31 Oct 2011 04:29:30 -0000
@@ -96,10 +96,7 @@
 
 #include <miscfs/kernfs/kernfs.h>
 
-#include "rnd.h"
-#if NRND > 0
-#include <sys/rnd.h>
-#endif
+#include <sys/cprng.h>
 
 #include <net/net_osdep.h>
 
@@ -4975,20 +4972,7 @@
 void
 key_randomfill(void *p, size_t l)
 {
-#if NRND == 0
-	static int warn = 1;
-#endif
-
-	arc4randbytes(p, l);
-
-#if NRND == 0
-	/* the arc4 generator is keyed with junk. */
-	if (warn) {
-		printf("WARNING: pseudo-random number generator "
-		    "used for IPsec processing\n");
-		warn = 0;
-	}
-#endif
+	cprng_fast(p, l);
 }
 
 /*
Index: nfs/nfs_subs.c
===================================================================
RCS file: /cvsroot/src/sys/nfs/nfs_subs.c,v
retrieving revision 1.221
diff -u -b -r1.221 nfs_subs.c
--- nfs/nfs_subs.c	12 Jun 2011 03:35:59 -0000	1.221
+++ nfs/nfs_subs.c	31 Oct 2011 04:29:30 -0000
@@ -98,6 +98,7 @@
 #include <sys/once.h>
 #include <sys/kauth.h>
 #include <sys/atomic.h>
+#include <sys/cprng.h>
 
 #include <uvm/uvm.h>
 
@@ -1488,7 +1489,7 @@
 	nfs_ticks = (hz * NFS_TICKINTVL + 500) / 1000;
 	if (nfs_ticks < 1)
 		nfs_ticks = 1;
-	nfs_xid = arc4random();
+	nfs_xid = cprng_fast32();
 	nfsdreq_init();
 
 	/*
Index: opencrypto/files.opencrypto
===================================================================
RCS file: /cvsroot/src/sys/opencrypto/files.opencrypto,v
retrieving revision 1.24
diff -u -b -r1.24 files.opencrypto
--- opencrypto/files.opencrypto	26 May 2011 21:50:03 -0000	1.24
+++ opencrypto/files.opencrypto	31 Oct 2011 04:29:30 -0000
@@ -15,7 +15,7 @@
 # Pseudo-device that provides software implementations of various cryptographic
 # algorithms.
 defpseudo swcrypto: opencrypto,
-		blowfish, des, cast128, rijndael, skipjack, camellia
+		blowfish, des, cast128, skipjack, camellia
 file	opencrypto/cryptosoft.c		swcrypto
 file	opencrypto/deflate.c		swcrypto	# wrapper around zlib
 file	opencrypto/aesxcbcmac.c		swcrypto
Index: rump/dev/lib/librnd/Makefile
===================================================================
RCS file: /cvsroot/src/sys/rump/dev/lib/librnd/Makefile,v
retrieving revision 1.2
diff -u -b -r1.2 Makefile
--- rump/dev/lib/librnd/Makefile	16 Feb 2010 20:42:45 -0000	1.2
+++ rump/dev/lib/librnd/Makefile	31 Oct 2011 04:29:30 -0000
@@ -5,7 +5,7 @@
 
 LIB=	rumpdev_rnd
 
-SRCS=   rnd.c rndpool.c
+#SRCS=   rnd.c rndpool.c
 
 SRCS+=	component.c
 
Index: rump/librump/rumpkern/Makefile.rumpkern
===================================================================
RCS file: /cvsroot/src/sys/rump/librump/rumpkern/Makefile.rumpkern,v
retrieving revision 1.110
diff -u -b -r1.110 Makefile.rumpkern
--- rump/librump/rumpkern/Makefile.rumpkern	12 Jun 2011 06:36:38 -0000	1.110
+++ rump/librump/rumpkern/Makefile.rumpkern	31 Oct 2011 04:29:30 -0000
@@ -20,7 +20,7 @@
 # 
 SRCS=	rump.c rumpcopy.c emul.c intr.c lwproc.c klock.c	\
 	kobj_rename.c ltsleep.c memalloc.c scheduler.c		\
-	signals.c sleepq.c threads.c vm.c
+	signals.c sleepq.c threads.c vm.c cprng_stub.c
 
 # Multiprocessor or uniprocessor locking.  TODO: select right
 # locking at runtime.
@@ -94,6 +94,7 @@
 	subr_lwp_specificdata.c	\
 	subr_once.c		\
 	subr_prf.c		\
+	subr_rngtest.c		\
 	subr_specificdata.c	\
 	subr_time.c		\
 	subr_workqueue.c	\
Index: rump/librump/rumpkern/cprng_stub.c
===================================================================
RCS file: rump/librump/rumpkern/cprng_stub.c
diff -N rump/librump/rumpkern/cprng_stub.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ rump/librump/rumpkern/cprng_stub.c	31 Oct 2011 04:29:30 -0000
@@ -0,0 +1,89 @@
+/*	$NetBSD: $ */
+
+/*-
+ * Copyright (c) 2011 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Thor Lancelot Simon.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <sys/types.h>
+#include <sys/time.h>
+#include <sys/param.h>
+#include <sys/kernel.h>
+#include <sys/systm.h>
+#include <sys/kmem.h>
+#include <sys/mutex.h>
+#include <sys/rngtest.h>
+
+#include <machine/cpu_counter.h>
+
+#include <sys/cprng.h>
+
+/*
+ * This is all stubbed out because of rump build dependency issues I
+ * cannot fix.  One is more-or-less caused by the longstanding bogosity
+ * that sys/dev/rnd.c implements *both* the in-kernel interface *and*
+ * the pseudodevice.  The other, by the fact that I am not smart enough
+ * to understand how to deal with code in rumpkern that depends on code
+ * that lives in sys/crypto.  Sigh.
+ */
+
+cprng_strong_t *kern_cprng = NULL;
+
+void
+cprng_init(void)
+{
+	return;
+}
+
+cprng_strong_t *cprng_strong_create(const char *const name, int ipl)
+{
+	cprng_strong_t *c;
+
+	c = kmem_alloc(sizeof(*c), KM_NOSLEEP);
+	if (c == NULL) {
+		return NULL;
+	}
+	strlcpy(c->name, name, sizeof(c->name));
+	mutex_init(&c->mtx, MUTEX_DEFAULT, ipl);
+	return c;
+}
+
+
+size_t cprng_strong(cprng_strong_t *c, void *p, size_t len)
+{
+	mutex_enter(&c->mtx);
+	cprng_fast(p, len);		/* XXX! */
+	mutex_exit(&c->mtx);
+	return len;
+}
+
+void cprng_strong_destroy(cprng_strong_t *c)
+{
+	mutex_destroy(&c->mtx);
+	memset(c, 0, sizeof(*c));
+	kmem_free(c, sizeof(*c));
+}
Index: rump/librump/rumpkern/rump.c
===================================================================
RCS file: /cvsroot/src/sys/rump/librump/rumpkern/rump.c,v
retrieving revision 1.234
diff -u -b -r1.234 rump.c
--- rump/librump/rumpkern/rump.c	22 Mar 2011 15:16:23 -0000	1.234
+++ rump/librump/rumpkern/rump.c	31 Oct 2011 04:29:30 -0000
@@ -69,6 +69,7 @@
 #include <sys/vmem.h>
 #include <sys/xcall.h>
 #include <sys/simplelock.h>
+#include <sys/cprng.h>
 
 #include <rump/rumpuser.h>
 
@@ -288,7 +289,7 @@
 	 * implementation.
 	 */
 	messthestack();
-	arc4random();
+	cprng_fast32();
 
 	if (rump_version != RUMP_VERSION) {
 		printf("rump version mismatch, %d vs. %d\n",
Index: rump/librump/rumpvfs/rumpblk.c
===================================================================
RCS file: /cvsroot/src/sys/rump/librump/rumpvfs/rumpblk.c,v
retrieving revision 1.46
diff -u -b -r1.46 rumpblk.c
--- rump/librump/rumpvfs/rumpblk.c	3 Feb 2011 22:16:11 -0000	1.46
+++ rump/librump/rumpvfs/rumpblk.c	31 Oct 2011 04:29:31 -0000
@@ -65,6 +65,7 @@
 #include <sys/malloc.h>
 #include <sys/queue.h>
 #include <sys/stat.h>
+#include <sys/cprng.h>
 
 #include <rump/rumpuser.h>
 
@@ -326,7 +327,7 @@
 		    &error) == 0) {
 			randstate = strtoul(buf, NULL, 10);
 		} else {
-			randstate = arc4random();
+			randstate = cprng_fast32();
 		}
 		printf("rumpblk: FAULT INJECTION ACTIVE! fail %d/%d. "
 		    "seed %u\n", blkfail, BLKFAIL_MAX, randstate);
Index: rump/net/lib/libshmif/if_shmem.c
===================================================================
RCS file: /cvsroot/src/sys/rump/net/lib/libshmif/if_shmem.c,v
retrieving revision 1.43
diff -u -b -r1.43 if_shmem.c
--- rump/net/lib/libshmif/if_shmem.c	2 Sep 2011 22:25:08 -0000	1.43
+++ rump/net/lib/libshmif/if_shmem.c	31 Oct 2011 04:29:31 -0000
@@ -37,6 +37,7 @@
 #include <sys/kthread.h>
 #include <sys/lock.h>
 #include <sys/vmem.h>
+#include <sys/cprng.h>
 
 #include <net/bpf.h>
 #include <net/if.h>
@@ -152,7 +153,7 @@
 	uint32_t randnum;
 	int error;
 
-	randnum = arc4random();
+	randnum = cprng_fast32();
 	memcpy(&enaddr[2], &randnum, sizeof(randnum));
 
 	sc = kmem_zalloc(sizeof(*sc), KM_SLEEP);
Index: rump/net/lib/libvirtif/if_virt.c
===================================================================
RCS file: /cvsroot/src/sys/rump/net/lib/libvirtif/if_virt.c,v
retrieving revision 1.24
diff -u -b -r1.24 if_virt.c
--- rump/net/lib/libvirtif/if_virt.c	7 Aug 2011 14:03:16 -0000	1.24
+++ rump/net/lib/libvirtif/if_virt.c	31 Oct 2011 04:29:31 -0000
@@ -38,6 +38,7 @@
 #include <sys/poll.h>
 #include <sys/sockio.h>
 #include <sys/socketvar.h>
+#include <sys/cprng.h>
 
 #include <net/bpf.h>
 #include <net/if.h>
@@ -102,7 +103,7 @@
 		    num, error);
 		return error;
 	}
-	enaddr[2] = arc4random() & 0xff;
+	enaddr[2] = cprng_fast32() & 0xff;
 	enaddr[5] = num;
 
 	sc = kmem_zalloc(sizeof(*sc), KM_SLEEP);
@@ -370,8 +371,8 @@
 	struct ethercom *ec;
 	uint8_t enaddr[ETHER_ADDR_LEN] = { 0xb2, 0x0a, 0x00, 0x0b, 0x0e, 0x01 };
 
-	enaddr[2] = arc4random() & 0xff;
-	enaddr[5] = arc4random() & 0xff;
+	enaddr[2] = cprng_fast32() & 0xff;
+	enaddr[5] = cprng_fast32() & 0xff;
 
 	ec = kmem_zalloc(sizeof(*ec), KM_SLEEP);
 
Index: sys/cprng.h
===================================================================
RCS file: sys/cprng.h
diff -N sys/cprng.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sys/cprng.h	31 Oct 2011 04:29:31 -0000
@@ -0,0 +1,94 @@
+/*	$NetBSD: $ */
+
+/*-
+ * Copyright (c) 2011 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Thor Lancelot Simon.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+#ifndef _CPRNG_H
+#define _CPRNG_H
+
+#include <sys/types.h>
+#include <lib/libkern/libkern.h>
+#include <sys/rnd.h>
+#include <crypto/nist_ctr_drbg/nist_ctr_drbg.h>
+
+static inline size_t
+cprng_fast(void *p, size_t len)
+{
+	arc4randbytes(p, len);
+	return len;
+}
+
+static inline uint32_t
+cprng_fast32(void)
+{
+	return arc4random();
+}
+
+static inline uint64_t
+cprng_fast64(void)
+{
+	uint64_t r;
+	arc4randbytes(&r, sizeof(r));
+	return r;
+}
+
+typedef struct _cprng_strong {
+	kmutex_t      mtx;
+	NIST_CTR_DRBG drbg;
+	char	      name[16];
+	int	      reseed_pending;
+	rndsink_t     reseed;
+} cprng_strong_t;
+
+cprng_strong_t *cprng_strong_create(const char *const, int);
+
+size_t cprng_strong(cprng_strong_t *, void *, size_t);
+
+void cprng_strong_destroy(cprng_strong_t *);
+
+extern cprng_strong_t *	kern_cprng;
+
+static inline uint32_t
+cprng_strong32(void)
+{
+	uint32_t r;
+	cprng_strong(kern_cprng, &r, sizeof(r));
+        return r;
+}
+
+static inline uint64_t
+cprng_strong64(void)
+{
+        uint64_t r;
+	cprng_strong(kern_cprng, &r, sizeof(r));
+        return r;
+}
+
+void cprng_init(void);
+
+#endif
Index: sys/queue.h
===================================================================
RCS file: /cvsroot/src/sys/sys/queue.h,v
retrieving revision 1.52
diff -u -b -r1.52 queue.h
--- sys/queue.h	20 Apr 2009 09:56:08 -0000	1.52
+++ sys/queue.h	31 Oct 2011 04:29:31 -0000
@@ -166,6 +166,10 @@
 		(var);							\
 		(var) = ((var)->field.le_next))
 
+#define	LIST_FOREACH_SAFE(var, head, field, tvar)			\
+	for ((var) = LIST_FIRST((head));				\
+		(var) && ((tvar) = LIST_NEXT((var), field), 1);		\
+		(var) = (tvar))
 /*
  * List access methods.
  */
Index: sys/rnd.h
===================================================================
RCS file: /cvsroot/src/sys/sys/rnd.h,v
retrieving revision 1.21
diff -u -b -r1.21 rnd.h
--- sys/rnd.h	28 Apr 2008 20:24:11 -0000	1.21
+++ sys/rnd.h	31 Oct 2011 04:29:31 -0000
@@ -43,6 +43,10 @@
 #include <sys/queue.h>
 #endif
 
+#ifdef _KERNEL
+#include <sys/rngtest.h>
+#endif
+
 #define	RND_DEV_RANDOM	0	/* minor devices for random and kinda random */
 #define	RND_DEV_URANDOM	1
 
@@ -82,26 +86,14 @@
 	uint32_t	generated;
 } rndpoolstat_t;
 
-
-typedef struct {
-	uint32_t	cursor;		/* current add point in the pool */
-	uint32_t	rotate;		/* how many bits to rotate by */
-	rndpoolstat_t	stats;		/* current statistics */
-	uint32_t	pool[RND_POOLWORDS]; /* random pool data */
-} rndpool_t;
-
+/* Sanitized random source view for userspace */
 typedef struct {
 	char		name[16];	/* device name */
-	uint32_t	last_time;	/* last time recorded */
-	uint32_t	last_delta;	/* last delta value */
-	uint32_t	last_delta2;	/* last delta2 value */
 	uint32_t	total;		/* entropy from this source */
 	uint32_t	type;		/* type */
 	uint32_t	flags;		/* flags */
-	void		*state;		/* state informaiton */
 } rndsource_t;
 
-
 /*
  * Flags to control the source.  Low byte is type, upper bits are flags.
  */
@@ -118,12 +110,36 @@
 #define	RND_TYPE_MAX		5	/* last type id used */
 
 #ifdef _KERNEL
-typedef struct __rndsource_element rndsource_element_t;
 
-struct __rndsource_element {
-	LIST_ENTRY(__rndsource_element) list; /* the linked list */
-	rndsource_t	data;		/* the actual data */
-};
+typedef struct krndsource {
+	LIST_ENTRY(krndsource) list;	/* the linked list */
+        char            name[16];       /* device name */
+        uint32_t        last_time;      /* last time recorded */
+        uint32_t        last_delta;     /* last delta value */
+        uint32_t        last_delta2;    /* last delta2 value */
+        uint32_t        total;          /* entropy from this source */
+        uint32_t        type;           /* type */
+        uint32_t        flags;          /* flags */
+        void            *state;         /* state informaiton */
+        size_t          test_cnt;       /* how much test data accumulated? */
+        rngtest_t	*test;          /* test data for RNG type sources */
+} krndsource_t;
+
+typedef struct rndsink {
+        TAILQ_ENTRY(rndsink) tailq;     /* the queue */
+        void            (*cb)(void *);  /* callback function when ready */
+        void            *arg;           /* callback function argument */
+        char            name[16];       /* sink name */
+        size_t          len;            /* how many bytes wanted/supplied */
+        uint8_t         data[64];       /* random data returned here */
+} rndsink_t;
+
+typedef struct {
+        uint32_t        cursor;         /* current add point in the pool */
+        uint32_t        rotate;         /* how many bits to rotate by */
+        rndpoolstat_t   stats;          /* current statistics */
+        uint32_t        pool[RND_POOLWORDS]; /* random pool data */
+} rndpool_t;
 
 /*
  * Used by rnd_extract_data() and rndpool_extract_data() to describe how
@@ -134,7 +150,7 @@
 				      (short read ok) */
 
 #define RND_ENABLED(rp) \
-        (((rp)->data.flags & RND_FLAG_NO_COLLECT) == 0)
+        (((rp)->flags & RND_FLAG_NO_COLLECT) == 0)
 
 void		rndpool_init(rndpool_t *);
 void		rndpool_init_global(void);
@@ -144,17 +160,18 @@
 uint32_t	*rndpool_get_pool(rndpool_t *);
 uint32_t	rndpool_get_poolsize(void);
 void		rndpool_add_data(rndpool_t *, void *, uint32_t, uint32_t);
-uint32_t	rndpool_extract_data(rndpool_t *, void *, uint32_t,
-		    uint32_t);
-
+uint32_t	rndpool_extract_data(rndpool_t *, void *, uint32_t, uint32_t);
 void		rnd_init(void);
-void		rnd_add_uint32(rndsource_element_t *, uint32_t);
-void		rnd_add_data(rndsource_element_t *, void *, uint32_t,
+void		rnd_add_uint32(krndsource_t *, uint32_t);
+void		rnd_add_data(krndsource_t *, const void *const, uint32_t,
 		    uint32_t);
 uint32_t	rnd_extract_data(void *, uint32_t, uint32_t);
-void		rnd_attach_source(rndsource_element_t *, const char *,
+void		rnd_attach_source(krndsource_t *, const char *,
 		    uint32_t, uint32_t);
-void		rnd_detach_source(rndsource_element_t *);
+void		rnd_detach_source(krndsource_t *);
+
+void		rndsink_attach(rndsink_t *);
+void		rndsink_detach(rndsink_t *);
 
 #endif /* _KERNEL */
 
